Heart Donors in JavaScript

Using ApexCharts with JavaScript

This Heart Donors example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [57600, 16800, 4200, 3400],
  chart: {
    type: 'unit',
    height: 470,
    animations: {
      enabled: true,
      speed: 900,
    },
  },
  labels: [
    'Repeat donors',
    'First-time',
    'Workplace drives',
    'Emergency call-ups',
  ],
  // Four hues, not four tints of one: at this dot size a lightness ramp is very
  // hard to read back, and the palest end all but disappears on a white card.
  // Crimson still carries two thirds of the heart, so the shape keeps its colour.
  colors: ['#E8264F', '#FF8A3D', '#00A6A0', '#1D4E89'],
  plotOptions: {
    unit: {
      layout: 'custom',
      // One of the shapes in apexcharts/unit-shapes.
      positions: 'heart',
      transition: 'flow',
      unitValue: 100,
      clusterLabels: {
        // Outer labels: each band is named in the margin with a leader line to
        // its own dots, the way a pie names its slices. It replaces the legend,
        // so no one has to match a swatch to a band.
        external: {
          show: true,
        },
      },
    },
  },
  legend: {
    show: false,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Heart Donors in React

Using ApexCharts with React

This Heart Donors example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [57600, 16800, 4200, 3400],
    options: {
      chart: {
        type: 'unit',
        height: 470,
        animations: {
          enabled: true,
          speed: 900,
        },
      },
      labels: [
        'Repeat donors',
        'First-time',
        'Workplace drives',
        'Emergency call-ups',
      ],
      // Four hues, not four tints of one: at this dot size a lightness ramp is very
      // hard to read back, and the palest end all but disappears on a white card.
      // Crimson still carries two thirds of the heart, so the shape keeps its colour.
      colors: ['#E8264F', '#FF8A3D', '#00A6A0', '#1D4E89'],
      plotOptions: {
        unit: {
          layout: 'custom',
          // One of the shapes in apexcharts/unit-shapes.
          positions: 'heart',
          transition: 'flow',
          unitValue: 100,
          clusterLabels: {
            // Outer labels: each band is named in the margin with a leader line to
            // its own dots, the way a pie names its slices. It replaces the legend,
            // so no one has to match a swatch to a band.
            external: {
              show: true,
            },
          },
        },
      },
      legend: {
        show: false,
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>82,000 blood donations, one dot per 100</h1>
        <p>
          The heart is a custom unit layout: a function that receives every dot
          and the plot rect and returns positions. Nothing is drawn under the
          dots, the dots are the shape. It packs itself from the outline at
          whatever dot count and chart size it is given.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={470}
            />
          </div>
        </div>

        <p className="note">1 dot = 100 donations</p>
      </div>
    </div>
  )
}

export default ApexChart

Heart Donors in Angular

Using ApexCharts with Angular

This Heart Donors example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [57600, 16800, 4200, 3400],
          chart: {
            type: 'unit',
            height: 470,
            animations: {
              enabled: true,
              speed: 900,
            },
          },
          labels: [
            'Repeat donors',
            'First-time',
            'Workplace drives',
            'Emergency call-ups',
          ],
          // Four hues, not four tints of one: at this dot size a lightness ramp is very
          // hard to read back, and the palest end all but disappears on a white card.
          // Crimson still carries two thirds of the heart, so the shape keeps its colour.
          colors: ['#E8264F', '#FF8A3D', '#00A6A0', '#1D4E89'],
          plotOptions: {
            unit: {
              layout: 'custom',
              // One of the shapes in apexcharts/unit-shapes.
              positions: 'heart',
              transition: 'flow',
              unitValue: 100,
              clusterLabels: {
                // Outer labels: each band is named in the margin with a leader line to
                // its own dots, the way a pie names its slices. It replaces the legend,
                // so no one has to match a swatch to a band.
                external: {
                  show: true,
                },
              },
            },
          },
          legend: {
            show: false,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Heart Donors in Vue

Using ApexCharts with Vue

This Heart Donors example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>82,000 blood donations, one dot per 100</h1>
      <p>
        The heart is a custom unit layout: a function that receives every dot
        and the plot rect and returns positions. Nothing is drawn under the
        dots, the dots are the shape. It packs itself from the outline at
        whatever dot count and chart size it is given.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="470"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <p class="note">1 dot = 100 donations</p>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [57600, 16800, 4200, 3400],
      chartOptions: {
        chart: {
          type: 'unit',
          height: 470,
          animations: {
            enabled: true,
            speed: 900,
          },
        },
        labels: [
          'Repeat donors',
          'First-time',
          'Workplace drives',
          'Emergency call-ups',
        ],
        // Four hues, not four tints of one: at this dot size a lightness ramp is very
        // hard to read back, and the palest end all but disappears on a white card.
        // Crimson still carries two thirds of the heart, so the shape keeps its colour.
        colors: ['#E8264F', '#FF8A3D', '#00A6A0', '#1D4E89'],
        plotOptions: {
          unit: {
            layout: 'custom',
            // One of the shapes in apexcharts/unit-shapes.
            positions: 'heart',
            transition: 'flow',
            unitValue: 100,
            clusterLabels: {
              // Outer labels: each band is named in the margin with a leader line to
              // its own dots, the way a pie names its slices. It replaces the legend,
              // so no one has to match a swatch to a band.
              external: {
                show: true,
              },
            },
          },
        },
        legend: {
          show: false,
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 720px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  color: #8592a0;
  font-size: 12px;
  text-align: center;
  margin: 16px 0 0;
}
</style>